## libbpp-core 2.0.2

=== CMakeLists.txt ===
# CMake script for Bio++ Core
# Author: Sylvain Gaillard and Julien Dutheil
# Created: 17/09/2010

# Global parameters
CMAKE_MINIMUM_REQUIRED(VERSION 2.6)
PROJECT(bpp-core CXX)
IF(NOT CMAKE_BUILD_TYPE)
  SET(CMAKE_BUILD_TYPE RelWithDebInfo CACHE STRING
      "Choose the type of build, options are: None Debug Release RelWithDebInfo MinSizeRel."
      FORCE)
ENDIF(NOT CMAKE_BUILD_TYPE)

SET(CMAKE_CXX_FLAGS "-Wall -Weffc++ -Wshadow")
IF(NOT NO_VIRTUAL_COV)
  SET(NO_VIRTUAL_COV FALSE CACHE BOOL
      "Disable covariant return type with virtual inheritance, for compilers that do not support it."
      FORCE)
ENDIF(NOT NO_VIRTUAL_COV)

IF(NO_VIRTUAL_COV)
  MESSAGE("-- Covariant return with virtual inheritance disabled.")
  SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DNO_VIRTUAL_COV=1")
ENDIF(NO_VIRTUAL_COV)

# Libtool-like version number
# CURRENT:REVISION:AGE => file.so.(C-A).A.R
# current:  The most recent interface number that this library implements.
# revision: The implementation number of the current interface.
# age:      The difference between the newest and oldest interfaces that this
#           library implements.
# In other words, the library implements all the interface numbers in the
# range from number current - age to current.
SET(BPPCORE_VERSION_CURRENT "2")
SET(BPPCORE_VERSION_REVISION "1")
SET(BPPCORE_VERSION_AGE "0")

# Effective version number computation
MATH(EXPR BPPCORE_VERSION_MAJOR "${BPPCORE_VERSION_CURRENT} - ${BPPCORE_VERSION_AGE}")
SET(BPPCORE_VERSION_MINOR ${BPPCORE_VERSION_AGE})
SET(BPPCORE_VERSION_PATCH ${BPPCORE_VERSION_REVISION})
SET(BPPCORE_VERSION "${BPPCORE_VERSION_MAJOR}.${BPPCORE_VERSION_MINOR}.${BPPCORE_VERSION_PATCH}")

# Subdirectories
ADD_SUBDIRECTORY(src)

# Doxygen
FIND_PACKAGE(Doxygen)
IF (DOXYGEN_FOUND)
  ADD_CUSTOM_TARGET (apidoc ${DOXYGEN_EXECUTABLE} Doxyfile)
  ADD_CUSTOM_TARGET (apidoc-stable cp Doxyfile Doxyfile-stable
    COMMAND echo "HTML_HEADER=header.html" >> Doxyfile-stable
    COMMAND ${DOXYGEN_EXECUTABLE} Doxyfile-stable )
ENDIF (DOXYGEN_FOUND)

# Packager
SET(CPACK_PACKAGE_NAME "libbpp-core")
SET(CPACK_PACKAGE_VENDOR "Bio++ Development Team")
SET(CPACK_PACKAGE_VERSION "2.0.2")
SET(CPACK_PACKAGE_VERSION_MAJOR "2")
SET(CPACK_PACKAGE_VERSION_MINOR "0")
SET(CPACK_PACKAGE_VERSION_PATCH "2")
SET(CPACK_PACKAGE_DESCRIPTION_SUMMARY "The Bio++ Core library")
SET(CPACK_RESOURCE_FILE_LICENSE "${CMAKE_SOURCE_DIR}/COPYING.txt")
SET(CPACK_RESOURCE_FILE_AUTHORS "${CMAKE_SOURCE_DIR}/AUTHORS.txt")
SET(CPACK_RESOURCE_FILE_INSTALL "${CMAKE_SOURCE_DIR}/INSTALL.txt")
SET(CPACK_SOURCE_GENERATOR "TGZ")
SET(CPACK_SOURCE_IGNORE_FILES
 "CMakeFiles"
 "Makefile"
 "_CPack_Packages"
 "CMakeCache.txt"
 ".*\\\\.cmake"
 ".*\\\\.git"
 ".*\\\\.gz"
 ".*\\\\.deb"
 ".*\\\\.rpm"
 ".*\\\\.dmg"
 ".*\\\\.sh"
 ".*\\\\..*\\\\.swp"
 "src/\\\\..*"
 "src/libbpp*"
 "debian/tmp"
 "debian/libbpp.*/"
 "debian/libbpp.*\\\\.so.*"
 "debian/libbpp.*\\\\.a"
 "debian/libbpp.*\\\\.substvars"
 "debian/libbpp.*\\\\.debhelper"
 "debian/debhelper\\\\.log"
 "html"
 "Core.tag"
 "Testing"
 "build-stamp"
 "genIncludes.py"
 "install_manifest.txt"
 "DartConfiguration.tcl"
 ${CPACK_SOURCE_IGNORE_FILES}
)
IF (MACOS)
  SET(CPACK_GENERATOR "Bundle")
ENDIF()

SET(CPACK_SOURCE_PACKAGE_FILE_NAME "${CMAKE_PROJECT_NAME}-${CPACK_PACKAGE_VERSION_MAJOR}.${CPACK_PACKAGE_VERSION_MINOR}.${CPACK_PACKAGE_VERSION_PATCH}")
SET(CPACK_DEBSOURCE_PACKAGE_FILE_NAME "lib${CMAKE_PROJECT_NAME}_${CPACK_PACKAGE_VERSION_MAJOR}.${CPACK_PACKAGE_VERSION_MINOR}.${CPACK_PACKAGE_VERSION_PATCH}.orig")
INCLUDE(CPack)

#This adds the 'dist' target
ADD_CUSTOM_TARGET(dist COMMAND ${CMAKE_MAKE_PROGRAM} package_source)

IF (UNIX)
#This creates deb packages:
ADD_CUSTOM_TARGET(origdist COMMAND cp ${CPACK_SOURCE_PACKAGE_FILE_NAME}.tar.gz ../${CPACK_DEBSOURCE_PACKAGE_FILE_NAME}.tar.gz)
ADD_DEPENDENCIES(origdist dist)
ADD_CUSTOM_TARGET(deb dpkg-buildpackage -uc -us -i${CPACK_SOURCE_PACKAGE_FILE_NAME}.tar.gz)
ADD_DEPENDENCIES(deb origdist)

#This creates rpm packages:
ADD_CUSTOM_TARGET(rpm rpmbuild -ta ${CPACK_SOURCE_PACKAGE_FILE_NAME}.tar.gz)
ADD_DEPENDENCIES(rpm dist)

ENDIF()

SET(CTEST_UPDATE_TYPE git)
ENABLE_TESTING()
INCLUDE(CTest)
IF (BUILD_TESTING)
  ADD_SUBDIRECTORY(test)
ENDIF(BUILD_TESTING)

=== src/CMakeLists.txt ===
# CMake script for Bio++ Core
# Author: Sylvain Gaillard and Julien Dutheil
# Created: 17/08/2009

# File list
set(CPP_FILES
  Bpp/Exceptions.cpp
  Bpp/BppString.cpp
  Bpp/App/ApplicationTools.cpp
  Bpp/App/BppApplication.cpp
  Bpp/App/NumCalcApplicationTools.cpp
  Bpp/Io/FileTools.cpp
  Bpp/Utils/AttributesTools.cpp
  Bpp/Text/KeyvalTools.cpp
  Bpp/Text/NestedStringTokenizer.cpp
  Bpp/Text/StringTokenizer.cpp
  Bpp/Text/TextTools.cpp
  Bpp/Graphics/ColorTools.cpp
  Bpp/Graphics/GraphicDevice.cpp
  Bpp/Graphics/Fig/XFigGraphicDevice.cpp
  Bpp/Graphics/Fig/XFigLaTeXFontManager.cpp
  Bpp/Graphics/Fig/XFigPostscriptFontManager.cpp
  Bpp/Graphics/Font/Font.cpp
  Bpp/Graphics/Latex/DvipsColorSet.cpp
  Bpp/Graphics/Latex/PgfGraphicDevice.cpp
  Bpp/Graphics/Molscript/MolscriptColorSet.cpp
  Bpp/Graphics/Svg/SvgGraphicDevice.cpp
  Bpp/Graphics/R/RColorSet.cpp
  Bpp/Numeric/NumTools.cpp
  Bpp/Numeric/Parameter.cpp
  Bpp/Numeric/ParameterExceptions.cpp
  Bpp/Numeric/ParameterList.cpp
  Bpp/Numeric/Random/RandomTools.cpp
  Bpp/Numeric/Random/ContingencyTableGenerator.cpp
  Bpp/Numeric/Random/Uniform01K.cpp
  Bpp/Numeric/Random/Uniform01QD.cpp
  Bpp/Numeric/Random/Uniform01WH.cpp
  Bpp/Numeric/AbstractParameterAliasable.cpp
  Bpp/Numeric/AbstractParametrizable.cpp
  Bpp/Numeric/AdaptiveKernelDensityEstimation.cpp
  Bpp/Numeric/VectorTools.cpp
  Bpp/Numeric/AutoParameter.cpp
  Bpp/Numeric/DataTable.cpp
  Bpp/Numeric/Domain.cpp
  Bpp/Numeric/IntervalData.cpp
  Bpp/Numeric/NumConstants.cpp
  Bpp/Numeric/Function/AbstractOptimizer.cpp
  Bpp/Numeric/Function/BrentOneDimension.cpp
  Bpp/Numeric/Function/ConjugateGradientMultiDimensions.cpp
  Bpp/Numeric/Function/DirectionFunction.cpp
  Bpp/Numeric/Function/DownhillSimplexMethod.cpp
  Bpp/Numeric/Function/FivePointsNumericalDerivative.cpp
  Bpp/Numeric/Function/FunctionTools.cpp
  Bpp/Numeric/Function/GoldenSectionSearch.cpp
  Bpp/Numeric/Function/MetaOptimizer.cpp
  Bpp/Numeric/Function/NewtonOneDimension.cpp
  Bpp/Numeric/Function/NewtonBacktrackOneDimension.cpp
  Bpp/Numeric/Function/BfgsMultiDimensions.cpp
  Bpp/Numeric/Function/OneDimensionOptimizationTools.cpp
  Bpp/Numeric/Function/OptimizationStopCondition.cpp
  Bpp/Numeric/Function/PowellMultiDimensions.cpp
  Bpp/Numeric/Function/ReparametrizationFunctionWrapper.cpp
  Bpp/Numeric/Function/SimpleMultiDimensions.cpp
  Bpp/Numeric/Function/SimpleNewtonMultiDimensions.cpp
  Bpp/Numeric/Function/ThreePointsNumericalDerivative.cpp
  Bpp/Numeric/Function/TwoPointsNumericalDerivative.cpp
  Bpp/Numeric/Hmm/LogsumHmmLikelihood.cpp
  Bpp/Numeric/Hmm/LowMemoryRescaledHmmLikelihood.cpp
  Bpp/Numeric/Hmm/RescaledHmmLikelihood.cpp
  Bpp/Numeric/Prob/AbstractDiscreteDistribution.cpp
  Bpp/Numeric/Prob/BetaDiscreteDistribution.cpp
  Bpp/Numeric/Prob/ConstantDistribution.cpp
  Bpp/Numeric/Prob/DirichletDiscreteDistribution.cpp
  Bpp/Numeric/Prob/ExponentialDiscreteDistribution.cpp
  Bpp/Numeric/Prob/GammaDiscreteDistribution.cpp
  Bpp/Numeric/Prob/GaussianDiscreteDistribution.cpp
  Bpp/Numeric/Prob/InvariantMixedDiscreteDistribution.cpp
  Bpp/Numeric/Prob/MixtureOfDiscreteDistributions.cpp
  Bpp/Numeric/Prob/SimpleDiscreteDistribution.cpp
  Bpp/Numeric/Prob/TruncatedExponentialDiscreteDistribution.cpp
  Bpp/Numeric/Prob/UniformDiscreteDistribution.cpp
  Bpp/Numeric/Stat/ContingencyTableTest.cpp
  Bpp/Numeric/Stat/StatTools.cpp
  Bpp/Numeric/Stat/Mva/DualityDiagram.cpp 
  Bpp/Numeric/Stat/Mva/PrincipalComponentAnalysis.cpp 
  Bpp/Numeric/Stat/Mva/CorrespondenceAnalysis.cpp 
  )

set(H_FILES
  Bpp/BppString.h
  Bpp/BppBoolean.h
  Bpp/BppVector.h
  Bpp/Clonable.h
  Bpp/Exceptions.h
  Bpp/App/ApplicationTools.h
  Bpp/App/BppApplication.h
  Bpp/App/NumCalcApplicationTools.h
  Bpp/Graphics/AbstractGraphicDevice.h
  Bpp/Graphics/ColorManager.h
  Bpp/Graphics/ColorSet.h
  Bpp/Graphics/ColorTools.h
  Bpp/Graphics/DefaultColorSet.h
  Bpp/Graphics/GraphicDevice.h
  Bpp/Graphics/Point2D.h
  Bpp/Graphics/Point2DTools.h
  Bpp/Graphics/RgbColor.h
  Bpp/Io/FileTools.h
  Bpp/Io/IoFormat.h
  Bpp/Io/OutputStream.h
  Bpp/Numeric/AbstractParameterAliasable.h
  Bpp/Numeric/AbstractParametrizable.h
  Bpp/Numeric/AdaptiveKernelDensityEstimation.h
  Bpp/Numeric/AutoParameter.h
  Bpp/Numeric/Constraints.h
  Bpp/Numeric/DataTableExceptions.h
  Bpp/Numeric/DataTable.h
  Bpp/Numeric/Domain.h
  Bpp/Numeric/IntervalData.h
  Bpp/Numeric/Number.h
  Bpp/Numeric/NumConstants.h
  Bpp/Numeric/NumTools.h
  Bpp/Numeric/ParameterAliasable.h
  Bpp/Numeric/ParameterExceptions.h
  Bpp/Numeric/Parameter.h
  Bpp/Numeric/ParameterList.h
  Bpp/Numeric/Parametrizable.h
  Bpp/Numeric/TransformedParameter.h
  Bpp/Numeric/Random/RandomFactory.h
  Bpp/Numeric/Random/RandomTools.h
  Bpp/Numeric/Random/ContingencyTableGenerator.h
  Bpp/Numeric/Random/Uniform01K.h
  Bpp/Numeric/Random/Uniform01QD.h
  Bpp/Numeric/Random/Uniform01WH.h
  Bpp/Numeric/VectorExceptions.h
  Bpp/Numeric/VectorTools.h
  Bpp/Text/KeyvalTools.h
  Bpp/Text/NestedStringTokenizer.h
  Bpp/Text/StringTokenizer.h
  Bpp/Text/TextTools.h
  Bpp/Utils/AttributesTools.h
  Bpp/Utils/MapTools.h
  Bpp/Graphics/Fig/XFigGraphicDevice.h
  Bpp/Graphics/Fig/XFigLaTeXFontManager.h
  Bpp/Graphics/Fig/XFigPostscriptFontManager.h
  Bpp/Graphics/Font/Font.h
  Bpp/Graphics/Font/FontManager.h
  Bpp/Graphics/Latex/DvipsColorSet.h
  Bpp/Graphics/Latex/PgfGraphicDevice.h
  Bpp/Graphics/Molscript/MolscriptColorSet.h
  Bpp/Graphics/R/RColorSet.h
  Bpp/Graphics/Svg/SvgGraphicDevice.h
  Bpp/Numeric/Function/AbstractNumericalDerivative.h
  Bpp/Numeric/Function/AbstractOptimizer.h
  Bpp/Numeric/Function/BrentOneDimension.h
  Bpp/Numeric/Function/ConjugateGradientMultiDimensions.h
  Bpp/Numeric/Function/DirectionFunction.h
  Bpp/Numeric/Function/DownhillSimplexMethod.h
  Bpp/Numeric/Function/FivePointsNumericalDerivative.h
  Bpp/Numeric/Function/Functions.h
  Bpp/Numeric/Function/FunctionTools.h
  Bpp/Numeric/Function/GoldenSectionSearch.h
  Bpp/Numeric/Function/MetaOptimizer.h
  Bpp/Numeric/Function/NewtonOneDimension.h
  Bpp/Numeric/Function/NewtonBacktrackOneDimension.h
  Bpp/Numeric/Function/BfgsMultiDimensions.h
  Bpp/Numeric/Function/OneDimensionOptimizationTools.h
  Bpp/Numeric/Function/OptimizationStopCondition.h
  Bpp/Numeric/Function/Optimizer.h
  Bpp/Numeric/Function/PowellMultiDimensions.h
  Bpp/Numeric/Function/ReparametrizationFunctionWrapper.h
  Bpp/Numeric/Function/SimpleMultiDimensions.h
  Bpp/Numeric/Function/SimpleNewtonMultiDimensions.h
  Bpp/Numeric/Function/ThreePointsNumericalDerivative.h
  Bpp/Numeric/Function/TwoPointsNumericalDerivative.h
  Bpp/Numeric/Hmm/HmmEmissionProbabilities.h
  Bpp/Numeric/Hmm/HmmExceptions.h
  Bpp/Numeric/Hmm/HmmLikelihood.h
  Bpp/Numeric/Hmm/HmmStateAlphabet.h
  Bpp/Numeric/Hmm/HmmTransitionMatrix.h
  Bpp/Numeric/Hmm/LogsumHmmLikelihood.h
  Bpp/Numeric/Hmm/LowMemoryRescaledHmmLikelihood.h
  Bpp/Numeric/Hmm/RescaledHmmLikelihood.h
  Bpp/Numeric/Matrix/EigenValue.h
  Bpp/Numeric/Matrix/LUDecomposition.h
  Bpp/Numeric/Matrix/Matrix.h
  Bpp/Numeric/Matrix/MatrixTools.h
  Bpp/Numeric/Prob/AbstractDiscreteDistribution.h
  Bpp/Numeric/Prob/BetaDiscreteDistribution.h
  Bpp/Numeric/Prob/ConstantDistribution.h
  Bpp/Numeric/Prob/DirichletDiscreteDistribution.h
  Bpp/Numeric/Prob/DiscreteDistribution.h
  Bpp/Numeric/Prob/ExponentialDiscreteDistribution.h
  Bpp/Numeric/Prob/GammaDiscreteDistribution.h
  Bpp/Numeric/Prob/GaussianDiscreteDistribution.h
  Bpp/Numeric/Prob/InvariantMixedDiscreteDistribution.h
  Bpp/Numeric/Prob/MixtureOfDiscreteDistributions.h
  Bpp/Numeric/Prob/MultipleDiscreteDistribution.h
  Bpp/Numeric/Prob/SimpleDiscreteDistribution.h
  Bpp/Numeric/Prob/TruncatedExponentialDiscreteDistribution.h
  Bpp/Numeric/Prob/UniformDiscreteDistribution.h
  Bpp/Numeric/Stat/StatTest.h 
  Bpp/Numeric/Stat/ContingencyTableTest.h 
  Bpp/Numeric/Stat/StatTools.h 
  Bpp/Numeric/Stat/Mva/DualityDiagram.h 
  Bpp/Numeric/Stat/Mva/PrincipalComponentAnalysis.h 
  Bpp/Numeric/Stat/Mva/CorrespondenceAnalysis.h 
)

# Build the static lib
add_library(bppcore-static STATIC ${CPP_FILES})
set_target_properties(bppcore-static
  PROPERTIES OUTPUT_NAME bpp-core
  CLEAN_DIRECT_OUTPUT 1
  )

# Build the shared lib
add_library(bppcore-shared SHARED ${CPP_FILES})
set_target_properties(bppcore-shared
  PROPERTIES OUTPUT_NAME bpp-core
  CLEAN_DIRECT_OUTPUT 1
  VERSION ${BPPCORE_VERSION}
  SOVERSION ${BPPCORE_VERSION_MAJOR}
  )

# Install libs
install(TARGETS bppcore-static bppcore-shared DESTINATION lib${LIB_SUFFIX})

# Install headers
install(DIRECTORY Bpp/ DESTINATION include/Bpp FILES_MATCHING PATTERN "*.h" PATTERN "*.all")

=== test/CMakeLists.txt ===
# CMake script for bpp-core unit tests
# Author: Julien Dutheil
# Created: 27/10/2010

MACRO(TEST_FIND_LIBRARY OUTPUT_LIBS lib_name include_to_find)
  #start:
  FIND_PATH(${lib_name}_INCLUDE_DIR ${include_to_find})

  SET(${lib_name}_NAMES ${lib_name} ${lib_name}.lib ${lib_name}.dll)
  FIND_LIBRARY(${lib_name}_LIBRARY NAMES ${${lib_name}_NAMES})
  IF(${lib_name}_LIBRARY)
    MESSAGE("-- Library ${lib_name} found here:")
    MESSAGE("   includes: ${${lib_name}_INCLUDE_DIR}")
    MESSAGE("   dynamic libraries: ${${lib_name}_LIBRARY}")
    MESSAGE(WARNING "Library ${lib_name} is already installed in the system tree. Test will be built against it. This may lead to unexpected results. You may want to do 'make install' before 'make test', or remove the installed version.")
  ELSE()
    SET(${lib_name}_LIBRARY "-L../src -lbpp-core")
    SET(${lib_name}_INCLUDE_DIR "../src/")
  ENDIF()
  INCLUDE_DIRECTORIES(${${lib_name}_INCLUDE_DIR})
  SET(${OUTPUT_LIBS} ${${OUTPUT_LIBS}} ${${lib_name}_LIBRARY})
ENDMACRO(TEST_FIND_LIBRARY)

#Find the bpp-core library library:
TEST_FIND_LIBRARY(LIBS bpp-core Bpp/Clonable.h)

ADD_EXECUTABLE(test_eigen test_eigen.cpp)
TARGET_LINK_LIBRARIES(test_eigen ${LIBS})
ADD_TEST(test_eigen "test_eigen")

ADD_EXECUTABLE(test_derivative1 test_derivative1.cpp)
TARGET_LINK_LIBRARIES(test_derivative1 ${LIBS})
ADD_TEST(test_derivative1 "test_derivative1")

ADD_EXECUTABLE(test_downhill test_downhill.cpp)
TARGET_LINK_LIBRARIES(test_downhill ${LIBS})
ADD_TEST(test_downhill "test_downhill")

ADD_EXECUTABLE(test_powell test_powell.cpp)
TARGET_LINK_LIBRARIES(test_powell ${LIBS})
ADD_TEST(test_powell "test_powell")

ADD_EXECUTABLE(test_gradient test_gradient.cpp)
TARGET_LINK_LIBRARIES(test_gradient ${LIBS})
ADD_TEST(test_gradient "test_gradient")

ADD_EXECUTABLE(test_bfgs test_bfgs.cpp)
TARGET_LINK_LIBRARIES(test_bfgs ${LIBS})
ADD_TEST(test_bfgs "test_bfgs")

ADD_EXECUTABLE(test_stats test_stats.cpp)
TARGET_LINK_LIBRARIES(test_stats ${LIBS})
ADD_TEST(test_stats "test_stats")

ADD_EXECUTABLE(test_mva test_mva.cpp)
TARGET_LINK_LIBRARIES(test_mva ${LIBS})
ADD_TEST(test_mva "test_mva")

IF(UNIX)
  SET_PROPERTY(TEST test_eigen test_derivative1 test_downhill test_powell test_gradient test_bfgs test_stats test_mva PROPERTY ENVIRONMENT "LD_LIBRARY_PATH=$ENV{LD_LIBRARY_PATH}:../src")
ENDIF()

IF(APPLE)
  SET_PROPERTY(TEST test_eigen test_derivative1 test_downhill test_powell test_gradient test_bfgs test_stats test_mva PROPERTY ENVIRONMENT "DYLD_LIBRARY_PATH=$ENV{DYLD_LIBRARY_PATH}:../src")
ENDIF()

IF(WIN32)
  SET(ENV{PATH} "$ENV{PATH}:../src")
ENDIF()

=== debian/changelog ===
libbpp-core (2.0.2-1) unstable; urgency=low

  * RFP: Bio++ -- The Bio++ bioinformatics libraries. (Closes: #616373).
  * Packages are now non-native.
  * More MatrixTools, multivariate analysis classes and several bugs fixed.

 -- Julien Dutheil <julien.dutheil@univ-montp2.fr>  Thu, 09 Jun 2011 11:00:00 +0100

libbpp-core (2.0.1) unstable; urgency=low

  * Fixed missing RColorSet.cpp source file.

 -- Julien Dutheil <julien.dutheil@univ-montp2.fr>  Mon, 28 Feb 2011 09:00:00 +0100

libbpp-core (2.0.0) unstable; urgency=low

  * New package merging old bpp-utils and bpp-numcalc.
  * New source tree.

 -- Julien Dutheil <julien.dutheil@univ-montp2.fr>  Mon, 07 Feb 2011 09:00:00 +0100

## libbpp-core 2.0.3

=== CMakeLists.txt ===
--- 
+++ 
@@ -32,7 +32,7 @@
 # In other words, the library implements all the interface numbers in the
 # range from number current - age to current.
 SET(BPPCORE_VERSION_CURRENT "2")
-SET(BPPCORE_VERSION_REVISION "1")
+SET(BPPCORE_VERSION_REVISION "2")
 SET(BPPCORE_VERSION_AGE "0")
 
 # Effective version number computation
@@ -56,10 +56,10 @@
 # Packager
 SET(CPACK_PACKAGE_NAME "libbpp-core")
 SET(CPACK_PACKAGE_VENDOR "Bio++ Development Team")
-SET(CPACK_PACKAGE_VERSION "2.0.2")
+SET(CPACK_PACKAGE_VERSION "2.0.3")
 SET(CPACK_PACKAGE_VERSION_MAJOR "2")
 SET(CPACK_PACKAGE_VERSION_MINOR "0")
-SET(CPACK_PACKAGE_VERSION_PATCH "2")
+SET(CPACK_PACKAGE_VERSION_PATCH "3")
 SET(CPACK_PACKAGE_DESCRIPTION_SUMMARY "The Bio++ Core library")
 SET(CPACK_RESOURCE_FILE_LICENSE "${CMAKE_SOURCE_DIR}/COPYING.txt")
 SET(CPACK_RESOURCE_FILE_AUTHORS "${CMAKE_SOURCE_DIR}/AUTHORS.txt")

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -15,6 +15,8 @@
   Bpp/Text/NestedStringTokenizer.cpp
   Bpp/Text/StringTokenizer.cpp
   Bpp/Text/TextTools.cpp
+  Bpp/Graph/BasicONode.cpp
+  Bpp/Graph/BasicTNode.cpp
   Bpp/Graphics/ColorTools.cpp
   Bpp/Graphics/GraphicDevice.cpp
   Bpp/Graphics/Fig/XFigGraphicDevice.cpp
@@ -67,6 +69,7 @@
   Bpp/Numeric/Hmm/LogsumHmmLikelihood.cpp
   Bpp/Numeric/Hmm/LowMemoryRescaledHmmLikelihood.cpp
   Bpp/Numeric/Hmm/RescaledHmmLikelihood.cpp
+  Bpp/Numeric/Prob/Simplex.cpp
   Bpp/Numeric/Prob/AbstractDiscreteDistribution.cpp
   Bpp/Numeric/Prob/BetaDiscreteDistribution.cpp
   Bpp/Numeric/Prob/ConstantDistribution.cpp
@@ -95,6 +98,11 @@
   Bpp/App/ApplicationTools.h
   Bpp/App/BppApplication.h
   Bpp/App/NumCalcApplicationTools.h
+  Bpp/Graph/UNode.h
+  Bpp/Graph/ONode.h
+  Bpp/Graph/TNode.h
+  Bpp/Graph/BasicONode.h
+  Bpp/Graph/BasicTNode.h
   Bpp/Graphics/AbstractGraphicDevice.h
   Bpp/Graphics/ColorManager.h
   Bpp/Graphics/ColorSet.h
@@ -133,6 +141,7 @@
   Bpp/Numeric/Random/Uniform01WH.h
   Bpp/Numeric/VectorExceptions.h
   Bpp/Numeric/VectorTools.h
+  Bpp/Numeric/Range.h
   Bpp/Text/KeyvalTools.h
   Bpp/Text/NestedStringTokenizer.h
   Bpp/Text/StringTokenizer.h
@@ -184,6 +193,7 @@
   Bpp/Numeric/Matrix/LUDecomposition.h
   Bpp/Numeric/Matrix/Matrix.h
   Bpp/Numeric/Matrix/MatrixTools.h
+  Bpp/Numeric/Prob/Simplex.h
   Bpp/Numeric/Prob/AbstractDiscreteDistribution.h
   Bpp/Numeric/Prob/BetaDiscreteDistribution.h
   Bpp/Numeric/Prob/ConstantDistribution.h

=== test/CMakeLists.txt ===
--- 
+++ 
@@ -28,6 +28,10 @@
 TARGET_LINK_LIBRARIES(test_eigen ${LIBS})
 ADD_TEST(test_eigen "test_eigen")
 
+ADD_EXECUTABLE(test_matrices test_matrices.cpp)
+TARGET_LINK_LIBRARIES(test_matrices ${LIBS})
+ADD_TEST(test_matrices "test_matrices")
+
 ADD_EXECUTABLE(test_derivative1 test_derivative1.cpp)
 TARGET_LINK_LIBRARIES(test_derivative1 ${LIBS})
 ADD_TEST(test_derivative1 "test_derivative1")
@@ -56,15 +60,27 @@
 TARGET_LINK_LIBRARIES(test_mva ${LIBS})
 ADD_TEST(test_mva "test_mva")
 
+ADD_EXECUTABLE(test_sample test_sample.cpp)
+TARGET_LINK_LIBRARIES(test_sample ${LIBS})
+ADD_TEST(test_sample "test_sample")
+
+ADD_EXECUTABLE(test_range test_range.cpp)
+TARGET_LINK_LIBRARIES(test_range ${LIBS})
+ADD_TEST(test_range "test_range")
+
+ADD_EXECUTABLE(test_text_tools test_text_tools.cpp)
+TARGET_LINK_LIBRARIES(test_text_tools ${LIBS})
+ADD_TEST(test_text_tools "test_text_tools")
+
 IF(UNIX)
-  SET_PROPERTY(TEST test_eigen test_derivative1 test_downhill test_powell test_gradient test_bfgs test_stats test_mva PROPERTY ENVIRONMENT "LD_LIBRARY_PATH=$ENV{LD_LIBRARY_PATH}:../src")
+  SET_PROPERTY(TEST test_eigen test_derivative1 test_downhill test_powell test_gradient test_bfgs test_stats test_mva test_range test_text_tools PROPERTY ENVIRONMENT "LD_LIBRARY_PATH=$ENV{LD_LIBRARY_PATH}:../src")
 ENDIF()
 
 IF(APPLE)
-  SET_PROPERTY(TEST test_eigen test_derivative1 test_downhill test_powell test_gradient test_bfgs test_stats test_mva PROPERTY ENVIRONMENT "DYLD_LIBRARY_PATH=$ENV{DYLD_LIBRARY_PATH}:../src")
+  SET_PROPERTY(TEST test_eigen test_derivative1 test_downhill test_powell test_gradient test_bfgs test_stats test_mva test_range test_text_tools PROPERTY ENVIRONMENT "DYLD_LIBRARY_PATH=$ENV{DYLD_LIBRARY_PATH}:../src")
 ENDIF()
 
 IF(WIN32)
-  SET(ENV{PATH} "$ENV{PATH}:../src")
+  SET(ENV{PATH} "$ENV{PATH};..\\src")
 ENDIF()

=== debian/changelog ===
libbpp-core (2.0.3-1) unstable; urgency=low

  * New range classes
  * Linear assigment method
  * Improved string tokenizer and text tools.

 -- Julien Dutheil <julien.dutheil@univ-montp2.fr>  Thu, 09 Feb 2012 13:00:00 +0100

## libbpp-core 2.1.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -11,7 +11,7 @@
       FORCE)
 ENDIF(NOT CMAKE_BUILD_TYPE)
 
-SET(CMAKE_CXX_FLAGS "-Wall -Weffc++ -Wshadow")
+SET(CMAKE_CXX_FLAGS "-Wall -Weffc++ -Wshadow -Wconversion")
 IF(NOT NO_VIRTUAL_COV)
   SET(NO_VIRTUAL_COV FALSE CACHE BOOL
       "Disable covariant return type with virtual inheritance, for compilers that do not support it."
@@ -32,7 +32,7 @@
 # In other words, the library implements all the interface numbers in the
 # range from number current - age to current.
 SET(BPPCORE_VERSION_CURRENT "2")
-SET(BPPCORE_VERSION_REVISION "2")
+SET(BPPCORE_VERSION_REVISION "3")
 SET(BPPCORE_VERSION_AGE "0")
 
 # Effective version number computation
@@ -41,25 +41,36 @@
 SET(BPPCORE_VERSION_PATCH ${BPPCORE_VERSION_REVISION})
 SET(BPPCORE_VERSION "${BPPCORE_VERSION_MAJOR}.${BPPCORE_VERSION_MINOR}.${BPPCORE_VERSION_PATCH}")
 
+# Set the CMAKE_PREFIX_PATH for the find_library fonction when using non
+# standard install location
+IF(CMAKE_INSTALL_PREFIX)
+  SET(CMAKE_PREFIX_PATH "${CMAKE_INSTALL_PREFIX}" ${CMAKE_PREFIX_PATH})
+ENDIF(CMAKE_INSTALL_PREFIX)
+
 # Subdirectories
 ADD_SUBDIRECTORY(src)
 
 # Doxygen
 FIND_PACKAGE(Doxygen)
 IF (DOXYGEN_FOUND)
-  ADD_CUSTOM_TARGET (apidoc ${DOXYGEN_EXECUTABLE} Doxyfile)
-  ADD_CUSTOM_TARGET (apidoc-stable cp Doxyfile Doxyfile-stable
-    COMMAND echo "HTML_HEADER=header.html" >> Doxyfile-stable
-    COMMAND ${DOXYGEN_EXECUTABLE} Doxyfile-stable )
+  ADD_CUSTOM_TARGET (apidoc cp Doxyfile ${CMAKE_BINARY_DIR}/Doxyfile-build
+    COMMAND echo "OUTPUT_DIRECTORY=${CMAKE_BINARY_DIR}" >> ${CMAKE_BINARY_DIR}/Doxyfile-build
+    COMMAND ${DOXYGEN_EXECUTABLE} ${CMAKE_BINARY_DIR}/Doxyfile-build
+    WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})
+  ADD_CUSTOM_TARGET (apidoc-stable cp Doxyfile ${CMAKE_BINARY_DIR}/Doxyfile-stable
+    COMMAND echo "OUTPUT_DIRECTORY=${CMAKE_BINARY_DIR}" >> ${CMAKE_BINARY_DIR}/Doxyfile-stable
+    COMMAND echo "HTML_HEADER=header.html" >> ${CMAKE_BINARY_DIR}/Doxyfile-stable
+    COMMAND ${DOXYGEN_EXECUTABLE} ${CMAKE_BINARY_DIR}/Doxyfile-stable
+    WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})
 ENDIF (DOXYGEN_FOUND)
 
 # Packager
 SET(CPACK_PACKAGE_NAME "libbpp-core")
 SET(CPACK_PACKAGE_VENDOR "Bio++ Development Team")
-SET(CPACK_PACKAGE_VERSION "2.0.3")
+SET(CPACK_PACKAGE_VERSION "2.1.0")
 SET(CPACK_PACKAGE_VERSION_MAJOR "2")
-SET(CPACK_PACKAGE_VERSION_MINOR "0")
-SET(CPACK_PACKAGE_VERSION_PATCH "3")
+SET(CPACK_PACKAGE_VERSION_MINOR "1")
+SET(CPACK_PACKAGE_VERSION_PATCH "0")
 SET(CPACK_PACKAGE_DESCRIPTION_SUMMARY "The Bio++ Core library")
 SET(CPACK_RESOURCE_FILE_LICENSE "${CMAKE_SOURCE_DIR}/COPYING.txt")
 SET(CPACK_RESOURCE_FILE_AUTHORS "${CMAKE_SOURCE_DIR}/AUTHORS.txt")
@@ -91,7 +102,6 @@
  "Core.tag"
  "Testing"
  "build-stamp"
- "genIncludes.py"
  "install_manifest.txt"
  "DartConfiguration.tcl"
  ${CPACK_SOURCE_IGNORE_FILES}
@@ -106,6 +116,14 @@
 
 #This adds the 'dist' target
 ADD_CUSTOM_TARGET(dist COMMAND ${CMAKE_MAKE_PROGRAM} package_source)
+# 'clean' is not (yet) a first class target. However, we need to clean the directories before building the sources:
+IF("${CMAKE_GENERATOR}" MATCHES "Make")
+  ADD_CUSTOM_TARGET(make_clean
+  COMMAND ${CMAKE_MAKE_PROGRAM} clean
+  WORKING_DIRECTORY ${CMAKE_CURRENT_DIR}
+  )
+  ADD_DEPENDENCIES(dist make_clean)
+ENDIF()
 
 IF (UNIX)
 #This creates deb packages:
@@ -121,6 +139,9 @@
 ENDIF()
 
 SET(CTEST_UPDATE_TYPE git)
+SET(UPDATE_COMMAND "git")
+SET(UPDATE_OPTIONS "")
+
 ENABLE_TESTING()
 INCLUDE(CTest)
 IF (BUILD_TESTING)

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -3,13 +3,16 @@
 # Created: 17/08/2009
 
 # File list
-set(CPP_FILES
+SET(CPP_FILES
   Bpp/Exceptions.cpp
   Bpp/BppString.cpp
   Bpp/App/ApplicationTools.cpp
   Bpp/App/BppApplication.cpp
   Bpp/App/NumCalcApplicationTools.cpp
   Bpp/Io/FileTools.cpp
+  Bpp/Io/BppOParametrizableFormat.cpp
+  Bpp/Io/BppODiscreteDistributionFormat.cpp
+  Bpp/Io/IoDiscreteDistributionFactory.cpp
   Bpp/Utils/AttributesTools.cpp
   Bpp/Text/KeyvalTools.cpp
   Bpp/Text/NestedStringTokenizer.cpp
@@ -43,9 +46,6 @@
   Bpp/Numeric/VectorTools.cpp
   Bpp/Numeric/AutoParameter.cpp
   Bpp/Numeric/DataTable.cpp
-  Bpp/Numeric/Domain.cpp
-  Bpp/Numeric/IntervalData.cpp
-  Bpp/Numeric/NumConstants.cpp
   Bpp/Numeric/Function/AbstractOptimizer.cpp
   Bpp/Numeric/Function/BrentOneDimension.cpp
   Bpp/Numeric/Function/ConjugateGradientMultiDimensions.cpp
@@ -89,7 +89,7 @@
   Bpp/Numeric/Stat/Mva/CorrespondenceAnalysis.cpp 
   )
 
-set(H_FILES
+SET(H_FILES
   Bpp/BppString.h
   Bpp/BppBoolean.h
   Bpp/BppVector.h
@@ -114,7 +114,12 @@
   Bpp/Graphics/RgbColor.h
   Bpp/Io/FileTools.h
   Bpp/Io/IoFormat.h
+  Bpp/Io/IoParametrizable.h
+  Bpp/Io/IoDiscreteDistribution.h
+  Bpp/Io/IoDiscreteDistributionFactory.h
   Bpp/Io/OutputStream.h
+  Bpp/Io/BppOParametrizableFormat.h
+  Bpp/Io/BppODiscreteDistributionFormat.h
   Bpp/Numeric/AbstractParameterAliasable.h
   Bpp/Numeric/AbstractParametrizable.h
   Bpp/Numeric/AdaptiveKernelDensityEstimation.h
@@ -122,8 +127,6 @@
   Bpp/Numeric/Constraints.h
   Bpp/Numeric/DataTableExceptions.h
   Bpp/Numeric/DataTable.h
-  Bpp/Numeric/Domain.h
-  Bpp/Numeric/IntervalData.h
   Bpp/Numeric/Number.h
   Bpp/Numeric/NumConstants.h
   Bpp/Numeric/NumTools.h
@@ -217,24 +220,29 @@
 )
 
 # Build the static lib
-add_library(bppcore-static STATIC ${CPP_FILES})
-set_target_properties(bppcore-static
+ADD_LIBRARY(bppcore-static STATIC ${CPP_FILES})
+SET_TARGET_PROPERTIES(bppcore-static
   PROPERTIES OUTPUT_NAME bpp-core
   CLEAN_DIRECT_OUTPUT 1
   )
+TARGET_LINK_LIBRARIES(bppcore-static ${LIBS})
 
 # Build the shared lib
-add_library(bppcore-shared SHARED ${CPP_FILES})
-set_target_properties(bppcore-shared
+ADD_LIBRARY(bppcore-shared SHARED ${CPP_FILES})
+SET_TARGET_PROPERTIES(bppcore-shared
   PROPERTIES OUTPUT_NAME bpp-core
   CLEAN_DIRECT_OUTPUT 1
   VERSION ${BPPCORE_VERSION}
   SOVERSION ${BPPCORE_VERSION_MAJOR}
   )
+TARGET_LINK_LIBRARIES(bppcore-shared ${LIBS})
 
 # Install libs
-install(TARGETS bppcore-static bppcore-shared DESTINATION lib${LIB_SUFFIX})
+INSTALL(TARGETS bppcore-static bppcore-shared DESTINATION lib${LIB_SUFFIX})
 
 # Install headers
-install(DIRECTORY Bpp/ DESTINATION include/Bpp FILES_MATCHING PATTERN "*.h" PATTERN "*.all")
-
+INSTALL(DIRECTORY Bpp/ DESTINATION include/Bpp FILES_MATCHING PATTERN "*.h")
+
+# Generate generic include files (.all)
+INSTALL(CODE "EXECUTE_PROCESS(COMMAND ${CMAKE_SOURCE_DIR}/genIncludes.sh ${CMAKE_PREFIX_PATH}/include/Bpp)")
+

=== test/CMakeLists.txt ===
--- 
+++ 
@@ -23,6 +23,10 @@
 
 #Find the bpp-core library library:
 TEST_FIND_LIBRARY(LIBS bpp-core Bpp/Clonable.h)
+
+ADD_EXECUTABLE(test_numconstants test_numconstants.cpp)
+TARGET_LINK_LIBRARIES(test_numconstants ${LIBS})
+ADD_TEST(test_numconstants "test_numconstants")
 
 ADD_EXECUTABLE(test_eigen test_eigen.cpp)
 TARGET_LINK_LIBRARIES(test_eigen ${LIBS})
@@ -52,6 +56,10 @@
 TARGET_LINK_LIBRARIES(test_bfgs ${LIBS})
 ADD_TEST(test_bfgs "test_bfgs")
 
+ADD_EXECUTABLE(test_distributions test_distributions.cpp)
+TARGET_LINK_LIBRARIES(test_distributions ${LIBS})
+ADD_TEST(test_distributions "test_distributions")
+
 ADD_EXECUTABLE(test_stats test_stats.cpp)
 TARGET_LINK_LIBRARIES(test_stats ${LIBS})
 ADD_TEST(test_stats "test_stats")
@@ -73,11 +81,11 @@
 ADD_TEST(test_text_tools "test_text_tools")
 
 IF(UNIX)
-  SET_PROPERTY(TEST test_eigen test_derivative1 test_downhill test_powell test_gradient test_bfgs test_stats test_mva test_range test_text_tools PROPERTY ENVIRONMENT "LD_LIBRARY_PATH=$ENV{LD_LIBRARY_PATH}:../src")
+  SET_PROPERTY(TEST test_numconstants test_eigen test_matrices test_derivative1 test_downhill test_powell test_gradient test_bfgs test_distributions test_stats test_mva test_sample test_range test_text_tools PROPERTY ENVIRONMENT "LD_LIBRARY_PATH=$ENV{LD_LIBRARY_PATH}:../src")
 ENDIF()
 
 IF(APPLE)
-  SET_PROPERTY(TEST test_eigen test_derivative1 test_downhill test_powell test_gradient test_bfgs test_stats test_mva test_range test_text_tools PROPERTY ENVIRONMENT "DYLD_LIBRARY_PATH=$ENV{DYLD_LIBRARY_PATH}:../src")
+  SET_PROPERTY(TEST test_numconstants test_eigen test_matrices test_derivative1 test_downhill test_powell test_gradient test_bfgs test_distributions test_stats test_mva test_sample test_range test_text_tools PROPERTY ENVIRONMENT "DYLD_LIBRARY_PATH=$ENV{DYLD_LIBRARY_PATH}:../src")
 ENDIF()
 
 IF(WIN32)

=== debian/changelog ===
libbpp-core (2.1.0-1ubuntu1) wily; urgency=medium

  * Rename library packages for g++5 ABI transition.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Tue, 04 Aug 2015 04:41:24 +0000

libbpp-core (2.1.0-1) unstable; urgency=low

  * Extended range classes
  * Improved initialization of static members
  * Extended support for BppO.

 -- Julien Dutheil <julien.dutheil@univ-montp2.fr>  Mon, 04 Mar 2013 10:15:00 +0100

=== debian/control ===
Source: libbpp-core
Section: libs
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Loic Dachary <loic@dachary.org>
Uploaders: Julien Dutheil <julien.dutheil@univ-montp2.fr>
Build-Depends: debhelper (>= 5), cmake (>= 2.6)
Standards-Version: 3.9.1

Package: libbpp-core-dev
Section: libdevel
Architecture: any
Depends: libbpp-core2v5 (= ${binary:Version}), ${misc:Depends}
Description: Bio++ Core library development files.
 Contains the Bio++ core classes.

Package: libbpp-core2v5
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Conflicts: libbpp-core2
Replaces: libbpp-core2
Description: Bio++ Core library.
 Contains the Bio++ core classes.

## libbpp-core 2.2.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -67,9 +67,9 @@
 # Packager
 SET(CPACK_PACKAGE_NAME "libbpp-core")
 SET(CPACK_PACKAGE_VENDOR "Bio++ Development Team")
-SET(CPACK_PACKAGE_VERSION "2.1.0")
+SET(CPACK_PACKAGE_VERSION "2.2.0")
 SET(CPACK_PACKAGE_VERSION_MAJOR "2")
-SET(CPACK_PACKAGE_VERSION_MINOR "1")
+SET(CPACK_PACKAGE_VERSION_MINOR "2")
 SET(CPACK_PACKAGE_VERSION_PATCH "0")
 SET(CPACK_PACKAGE_DESCRIPTION_SUMMARY "The Bio++ Core library")
 SET(CPACK_RESOURCE_FILE_LICENSE "${CMAKE_SOURCE_DIR}/COPYING.txt")
@@ -87,7 +87,6 @@
  ".*\\\\.deb"
  ".*\\\\.rpm"
  ".*\\\\.dmg"
- ".*\\\\.sh"
  ".*\\\\..*\\\\.swp"
  "src/\\\\..*"
  "src/libbpp*"

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -66,6 +66,10 @@
   Bpp/Numeric/Function/SimpleNewtonMultiDimensions.cpp
   Bpp/Numeric/Function/ThreePointsNumericalDerivative.cpp
   Bpp/Numeric/Function/TwoPointsNumericalDerivative.cpp
+  Bpp/Numeric/Hmm/HmmLikelihood.cpp
+  Bpp/Numeric/Hmm/AbstractHmmTransitionMatrix.cpp
+  Bpp/Numeric/Hmm/FullHmmTransitionMatrix.cpp
+  Bpp/Numeric/Hmm/AutoCorrelationTransitionMatrix.cpp
   Bpp/Numeric/Hmm/LogsumHmmLikelihood.cpp
   Bpp/Numeric/Hmm/LowMemoryRescaledHmmLikelihood.cpp
   Bpp/Numeric/Hmm/RescaledHmmLikelihood.cpp
@@ -135,6 +139,7 @@
   Bpp/Numeric/Parameter.h
   Bpp/Numeric/ParameterList.h
   Bpp/Numeric/Parametrizable.h
+  Bpp/Numeric/ParametrizableCollection.cpp
   Bpp/Numeric/TransformedParameter.h
   Bpp/Numeric/Random/RandomFactory.h
   Bpp/Numeric/Random/RandomTools.h
@@ -189,6 +194,9 @@
   Bpp/Numeric/Hmm/HmmLikelihood.h
   Bpp/Numeric/Hmm/HmmStateAlphabet.h
   Bpp/Numeric/Hmm/HmmTransitionMatrix.h
+  Bpp/Numeric/Hmm/AbstractHmmTransitionMatrix.h
+  Bpp/Numeric/Hmm/FullHmmTransitionMatrix.h
+  Bpp/Numeric/Hmm/AutoCorrelationTransitionMatrix.h
   Bpp/Numeric/Hmm/LogsumHmmLikelihood.h
   Bpp/Numeric/Hmm/LowMemoryRescaledHmmLikelihood.h
   Bpp/Numeric/Hmm/RescaledHmmLikelihood.h

=== test/CMakeLists.txt ===
--- 
+++ 
@@ -40,6 +40,10 @@
 TARGET_LINK_LIBRARIES(test_derivative1 ${LIBS})
 ADD_TEST(test_derivative1 "test_derivative1")
 
+ADD_EXECUTABLE(test_reparametrization test_reparametrization.cpp)
+TARGET_LINK_LIBRARIES(test_reparametrization ${LIBS})
+ADD_TEST(test_reparametrization "test_reparametrization")
+
 ADD_EXECUTABLE(test_downhill test_downhill.cpp)
 TARGET_LINK_LIBRARIES(test_downhill ${LIBS})
 ADD_TEST(test_downhill "test_downhill")
@@ -59,6 +63,10 @@
 ADD_EXECUTABLE(test_distributions test_distributions.cpp)
 TARGET_LINK_LIBRARIES(test_distributions ${LIBS})
 ADD_TEST(test_distributions "test_distributions")
+
+ADD_EXECUTABLE(test_simplex test_simplex.cpp)
+TARGET_LINK_LIBRARIES(test_simplex ${LIBS})
+ADD_TEST(test_simplex "test_simplex")
 
 ADD_EXECUTABLE(test_stats test_stats.cpp)
 TARGET_LINK_LIBRARIES(test_stats ${LIBS})
@@ -81,11 +89,11 @@
 ADD_TEST(test_text_tools "test_text_tools")
 
 IF(UNIX)
-  SET_PROPERTY(TEST test_numconstants test_eigen test_matrices test_derivative1 test_downhill test_powell test_gradient test_bfgs test_distributions test_stats test_mva test_sample test_range test_text_tools PROPERTY ENVIRONMENT "LD_LIBRARY_PATH=$ENV{LD_LIBRARY_PATH}:../src")
+  SET_PROPERTY(TEST test_numconstants test_eigen test_matrices test_derivative1 test_reparametrization test_downhill test_powell test_gradient test_bfgs test_distributions test_stats test_mva test_sample test_range test_text_tools test_simplex PROPERTY ENVIRONMENT "LD_LIBRARY_PATH=$ENV{LD_LIBRARY_PATH}:../src")
 ENDIF()
 
 IF(APPLE)
-  SET_PROPERTY(TEST test_numconstants test_eigen test_matrices test_derivative1 test_downhill test_powell test_gradient test_bfgs test_distributions test_stats test_mva test_sample test_range test_text_tools PROPERTY ENVIRONMENT "DYLD_LIBRARY_PATH=$ENV{DYLD_LIBRARY_PATH}:../src")
+  SET_PROPERTY(TEST test_numconstants test_eigen test_matrices test_derivative1 test_reparametrization test_downhill test_powell test_gradient test_bfgs test_distributions test_stats test_mva test_sample test_range test_text_tools test_simplex PROPERTY ENVIRONMENT "DYLD_LIBRARY_PATH=$ENV{DYLD_LIBRARY_PATH}:../src")
 ENDIF()
 
 IF(WIN32)

=== debian/changelog ===
libbpp-core (2.2.0-3) unstable; urgency=medium

  * Team upload
  [ Andreas Tille ]
  * d/postrm: remove useless ldconfig call
  * hardening=+bindnow

  [ Gert Wollny ]
  * d/p/gcc-6.patch: fix compilation with g++-6, Closes: #811657
  * cme fix dpkg-control
  * d/p/unforce..: Do not force CXX flags from CMake file 

 -- Gert Wollny <gw.fossdev@gmail.com>  Thu, 09 Jun 2016 15:50:20 +0200

libbpp-core (2.2.0-2) unstable; urgency=medium

  * Fix installation via d-shlibmove
  * d/compat: 9

 -- Andreas Tille <tille@debian.org>  Thu, 21 Apr 2016 17:01:36 +0200

libbpp-core (2.2.0-1) unstable; urgency=medium

  * New upstream version
  * Moved to Debian Med Git
  * Better description
    Closes: #641931
  * Team maintenance in Debian Med team
  * wrote watch file
  * DEP5 copyright
  * Short dh rules file
  * Use d-shlibs
  * Library transition
    Closes: #791093

 -- Andreas Tille <tille@debian.org>  Fri, 08 Apr 2016 23:52:21 +0200

=== debian/control ===
Source: libbpp-core
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Julien Dutheil <julien.dutheil@univ-montp2.fr>,
           Andreas Tille <tille@debian.org>
Section: science
Priority: optional
Build-Depends: debhelper (>= 9),
               cmake,
               d-shlibs
Standards-Version: 3.9.8
Vcs-Browser: https://anonscm.debian.org/cgit/debian-med/libbpp-core.git
Vcs-Git: https://anonscm.debian.org/git/debian-med/libbpp-core.git
Homepage: http://biopp.univ-montp2.fr/wiki/index.php/Main_Page

Package: libbpp-core-dev
Architecture: any
Section: libdevel
Depends: libbpp-core2v5 (= ${binary:Version}),
         ${misc:Depends}
Description: Bio++ Core library development files
 Bio++ is a set of C++ libraries for Bioinformatics, including sequence
 analysis, phylogenetics, molecular evolution and population genetics.
 Bio++ is Object Oriented and is designed to be both easy to use and
 computer efficient. Bio++ intends to help programmers to write computer
 expensive programs, by providing them a set of re-usable tools.
 .
 This package contains the static library and the header files of the
 Bio++ core classes.

Package: libbpp-core2v5
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Conflicts: libbpp-core2
Replaces: libbpp-core2
Description: Bio++ Core library
 Bio++ is a set of C++ libraries for Bioinformatics, including sequence
 analysis, phylogenetics, molecular evolution and population genetics.
 Bio++ is Object Oriented and is designed to be both easy to use and
 computer efficient. Bio++ intends to help programmers to write computer
 expensive programs, by providing them a set of re-usable tools.
 .
 This package contains the dynamic library of the Bio++ core classes.

=== debian/rules ===
#!/usr/bin/make -f
# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export DEB_BUILD_MAINT_OPTIONS = hardening=+bindnow

DEBPKGNAME := $(shell dpkg-parsechangelog | awk '/^Source:/ {print $$2}')

CMAKE_EXTRA_FLAGS += -DBUILD_TESTING=OFF

## The following has no visible effect ->
## W: libbpp-core2v5: hardening-no-relro usr/lib/x86_64-linux-gnu/libbpp-core.so.2.0.3
## remains
# export DEB_BUILD_MAINT_OPTIONS = hardening=+all
##
## A workaround is provided here:
##   https://sources.debian.net/src/keyutils/1.5.9-9/debian/patches/hardening.patch/
## See also the thread starting at
##   https://lists.debian.org/debian-devel/2016/05/msg00297.html

%:
	dh $@

override_dh_install:
	dh_install
	d-shlibmove --commit \
		    --multiarch \
		    --v5 \
		    --devunversioned \
		    --exclude-la \
                    --movedev debian/tmp/usr/include/* usr/include \
                    debian/tmp/usr/lib/*.so

=== debian/watch ===
version=3

http://biopp.univ-montp2.fr/Repositories/sources/ bpp-core-(\d[\d.]+)\.tar\.gz

## libbpp-core 2.3.1

=== CMakeLists.txt ===
# CMake script for Bio++ Core
# Authors:
#   Sylvain Gaillard
#   Julien Dutheil
#   Francois Gindraud (2017)
# Created: 17/09/2010

cmake_minimum_required (VERSION 2.8.11)
project (bpp-core CXX)

# Compile options
set (CMAKE_CXX_FLAGS "-std=c++11 -Wall -Weffc++ -Wshadow -Wconversion")

IF(NOT CMAKE_BUILD_TYPE)
  SET(CMAKE_BUILD_TYPE RelWithDebInfo CACHE STRING
      "Choose the type of build, options are: None Debug Release RelWithDebInfo MinSizeRel."
      FORCE)
ENDIF(NOT CMAKE_BUILD_TYPE)

# Libtool-like version number
# CURRENT:REVISION:AGE => file.so.(C-A).A.R
# current:  The most recent interface number that this library implements.
# revision: The implementation number of the current interface.
# age:      The difference between the newest and oldest interfaces that this
#           library implements.
# In other words, the library implements all the interface numbers in the
# range from number current - age to current.
SET(${PROJECT_NAME}_VERSION_CURRENT "3")
SET(${PROJECT_NAME}_VERSION_REVISION "0")
SET(${PROJECT_NAME}_VERSION_AGE "0")

# Effective version number computation
MATH(EXPR ${PROJECT_NAME}_VERSION_MAJOR "${${PROJECT_NAME}_VERSION_CURRENT} - ${${PROJECT_NAME}_VERSION_AGE}")
SET(${PROJECT_NAME}_VERSION_MINOR ${${PROJECT_NAME}_VERSION_AGE})
SET(${PROJECT_NAME}_VERSION_PATCH ${${PROJECT_NAME}_VERSION_REVISION})
SET(${PROJECT_NAME}_VERSION "${${PROJECT_NAME}_VERSION_MAJOR}.${${PROJECT_NAME}_VERSION_MINOR}.${${PROJECT_NAME}_VERSION_PATCH}")

set (PROJECT_VERSION ${${PROJECT_NAME}_VERSION})

include (GNUInstallDirs)

# CMake package
set (cmake-package-location ${CMAKE_INSTALL_LIBDIR}/cmake/${PROJECT_NAME})
include (CMakePackageConfigHelpers)
configure_package_config_file (
  package.cmake.in
  ${CMAKE_CURRENT_BINARY_DIR}/package.cmake
  INSTALL_DESTINATION ${cmake-package-location}
  )
write_basic_package_version_file (
  ${CMAKE_CURRENT_BINARY_DIR}/package-version.cmake
  VERSION ${PROJECT_VERSION}
  COMPATIBILITY SameMajorVersion
  )
install (FILES ${CMAKE_CURRENT_BINARY_DIR}/package.cmake DESTINATION ${cmake-package-location}
  RENAME ${PROJECT_NAME}-config.cmake)
install (FILES ${CMAKE_CURRENT_BINARY_DIR}/package-version.cmake DESTINATION ${cmake-package-location}
  RENAME ${PROJECT_NAME}-config-version.cmake)

# Define the libraries
add_subdirectory (src)

# Doxygen
FIND_PACKAGE(Doxygen)
IF (DOXYGEN_FOUND)
  ADD_CUSTOM_TARGET (apidoc cp Doxyfile ${CMAKE_BINARY_DIR}/Doxyfile-build
    COMMAND echo "OUTPUT_DIRECTORY=${CMAKE_BINARY_DIR}" >> ${CMAKE_BINARY_DIR}/Doxyfile-build
    COMMAND ${DOXYGEN_EXECUTABLE} ${CMAKE_BINARY_DIR}/Doxyfile-build
    WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})
  ADD_CUSTOM_TARGET (apidoc-stable cp Doxyfile ${CMAKE_BINARY_DIR}/Doxyfile-stable
    COMMAND echo "OUTPUT_DIRECTORY=${CMAKE_BINARY_DIR}" >> ${CMAKE_BINARY_DIR}/Doxyfile-stable
    COMMAND echo "HTML_HEADER=header.html" >> ${CMAKE_BINARY_DIR}/Doxyfile-stable
    COMMAND ${DOXYGEN_EXECUTABLE} ${CMAKE_BINARY_DIR}/Doxyfile-stable
    WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})
ENDIF (DOXYGEN_FOUND)

# Packager
SET(CPACK_PACKAGE_NAME "libbpp-core")
SET(CPACK_PACKAGE_VENDOR "Bio++ Development Team")
SET(CPACK_PACKAGE_VERSION "2.3.1")
SET(CPACK_PACKAGE_VERSION_MAJOR "2")
SET(CPACK_PACKAGE_VERSION_MINOR "3")
SET(CPACK_PACKAGE_VERSION_PATCH "1")
SET(CPACK_PACKAGE_DESCRIPTION_SUMMARY "The Bio++ Core library")
SET(CPACK_RESOURCE_FILE_LICENSE "${CMAKE_SOURCE_DIR}/COPYING.txt")
SET(CPACK_RESOURCE_FILE_AUTHORS "${CMAKE_SOURCE_DIR}/AUTHORS.txt")
SET(CPACK_RESOURCE_FILE_INSTALL "${CMAKE_SOURCE_DIR}/INSTALL.txt")
SET(CPACK_SOURCE_GENERATOR "TGZ")
# /!\ This assumes that an external build is used
SET(CPACK_SOURCE_IGNORE_FILES 
       "/build/" 
       "/\\\\.git/" 
       "/\\\\.gitignore" 
       ${CPACK_SOURCE_IGNORE_FILES}
       )

SET(CPACK_SOURCE_PACKAGE_FILE_NAME "${CMAKE_PROJECT_NAME}-${CPACK_PACKAGE_VERSION_MAJOR}.${CPACK_PACKAGE_VERSION_MINOR}.${CPACK_PACKAGE_VERSION_PATCH}")
SET(CPACK_DEBSOURCE_PACKAGE_FILE_NAME "lib${CMAKE_PROJECT_NAME}_${CPACK_PACKAGE_VERSION_MAJOR}.${CPACK_PACKAGE_VERSION_MINOR}.${CPACK_PACKAGE_VERSION_PATCH}.orig")
INCLUDE(CPack)

#This adds the 'dist' target
ADD_CUSTOM_TARGET(dist COMMAND ${CMAKE_MAKE_PROGRAM} package_source)

IF (UNIX)

#This creates rpm packages:
ADD_CUSTOM_TARGET(rpm rpmbuild -ta ${CPACK_SOURCE_PACKAGE_FILE_NAME}.tar.gz)
ADD_DEPENDENCIES(rpm dist)

ENDIF()

SET(CTEST_UPDATE_TYPE git)
SET(UPDATE_COMMAND "git")
SET(UPDATE_OPTIONS "")

# Tests
enable_testing ()
include (CTest)
if (BUILD_TESTING)
  add_subdirectory (test)
endif (BUILD_TESTING)

=== debian/changelog ===
libbpp-core (2.3.1-5) unstable; urgency=medium

  * Rebuild with gcc-7
  * Standards-Version: 4.0.1

 -- Andreas Tille <tille@debian.org>  Wed, 23 Aug 2017 19:30:10 +0200

libbpp-core (2.3.1-4) unstable; urgency=medium

  [ Julien Dutheil ]
  * Removed deprecated postint scripts. 

  [ Andreas Tille ]
  * hardening=+all
  * Standards-Version: 4.0.0 (no changes needed)

 -- Julien Dutheil <julien.dutheil@univ-montp2.fr>  Tue, 18 Jul 2017 08:55:54 +0200

libbpp-core (2.3.1-3) unstable; urgency=medium

  * cmake files belong to /usr/lib/$(DEB_HOST_MULTIARCH)

 -- Andreas Tille <tille@debian.org>  Thu, 22 Jun 2017 20:50:40 +0200

libbpp-core (2.3.1-2) unstable; urgency=medium

  * debhelper 10
  * Make sure cmake files will be found by d-shlibs
    Closes: #865466

 -- Andreas Tille <tille@debian.org>  Wed, 21 Jun 2017 21:09:41 +0200

libbpp-core (2.3.1-1) unstable; urgency=medium

  * New upstream version
    Closes: #864188
  * Install cmake files into development package

 -- Andreas Tille <tille@debian.org>  Tue, 13 Jun 2017 11:41:39 +0200

libbpp-core (2.3.0-1~exp1) unstable; urgency=medium

  * New upstream version
  * d/watch: point to github

 -- Andreas Tille <tille@debian.org>  Fri, 02 Jun 2017 23:10:15 +0200

=== debian/control ===
--- 
+++ 
@@ -4,10 +4,10 @@
            Andreas Tille <tille@debian.org>
 Section: science
 Priority: optional
-Build-Depends: debhelper (>= 9),
+Build-Depends: debhelper (>= 10),
                cmake,
                d-shlibs
-Standards-Version: 3.9.8
+Standards-Version: 4.0.1
 Vcs-Browser: https://anonscm.debian.org/cgit/debian-med/libbpp-core.git
 Vcs-Git: https://anonscm.debian.org/git/debian-med/libbpp-core.git
 Homepage: http://biopp.univ-montp2.fr/wiki/index.php/Main_Page
@@ -15,7 +15,7 @@
 Package: libbpp-core-dev
 Architecture: any
 Section: libdevel
-Depends: libbpp-core2v5 (= ${binary:Version}),
+Depends: libbpp-core3 (= ${binary:Version}),
          ${misc:Depends}
 Description: Bio++ Core library development files
  Bio++ is a set of C++ libraries for Bioinformatics, including sequence
@@ -27,14 +27,12 @@
  This package contains the static library and the header files of the
  Bio++ core classes.
 
-Package: libbpp-core2v5
+Package: libbpp-core3
 Architecture: any
 Multi-Arch: same
 Section: libs
 Depends: ${shlibs:Depends},
          ${misc:Depends}
-Conflicts: libbpp-core2
-Replaces: libbpp-core2
 Description: Bio++ Core library
  Bio++ is a set of C++ libraries for Bioinformatics, including sequence
  analysis, phylogenetics, molecular evolution and population genetics.
